variables:
  DOCKER_DRIVER: overlay
  CONTAINER_TEST_IMAGE: registry.gitlab.com/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME:$CI_BUILD_REF_NAME
  CONTAINER_RELEASE_IMAGE: registry.gitlab.com/$CI_PROJECT_NAMESPACE/$CI_PROJECT_NAME:latest

stages:
  - package
  - release
  - deploy

package:
  stage: package
  image: docker:latest
  services:
    - docker:dind
  before_script:
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
    - docker info
  script:
    - docker build -t $CONTAINER_TEST_IMAGE .
    - docker push $CONTAINER_TEST_IMAGE

release:
  stage: release
  image: docker:latest
  services:
    - docker:dind
  before_script:
    - docker login -u gitlab-ci-token -p $CI_BUILD_TOKEN registry.gitlab.com
    - docker info
  script:
    - docker pull $CONTAINER_TEST_IMAGE
    - docker tag $CONTAINER_TEST_IMAGE $CONTAINER_RELEASE_IMAGE
    - docker push $CONTAINER_RELEASE_IMAGE
  only:
    - develop
    - master

deploy-develop:
  image: google/cloud-sdk
  stage: deploy
  script:
    - echo "$GOOGLE_KEY" > key.json
    - gcloud auth activate-service-account --key-file key.json
    - gcloud config set container/use_client_certificate True
    - gcloud container clusters get-credentials fabmedical-arebts --zone europe-west1-b --project microservices101-arebts
    - kubectl apply -f deployment.develop.yaml --namespace=develop
  only:
    - develop
  environment:
    name: develop

deploy-production:
  image: google/cloud-sdk
  stage: deploy
  script:
    - echo "$GOOGLE_KEY" > key.json # Google Cloud service account key
    - gcloud auth activate-service-account --key-file key.json
    - gcloud config set container/use_client_certificate True
    - gcloud container clusters get-credentials fabmedical-arebts --zone europe-west1-b --project microservices101-arebts
    - kubectl apply -f deployment.master.yaml --namespace=production
  only:
    - master
  environment:
    name: production
